package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.ASN1Choice;
import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERBMPString;
import cn.com.infosec.asn1.DERIA5String;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERString;
import cn.com.infosec.asn1.DERUTF8String;
import cn.com.infosec.asn1.DERVisibleString;

public class DisplayText extends ASN1Encodable implements ASN1Choice {
   public static final int CONTENT_TYPE_IA5STRING = 0;
   public static final int CONTENT_TYPE_BMPSTRING = 1;
   public static final int CONTENT_TYPE_UTF8STRING = 2;
   public static final int CONTENT_TYPE_VISIBLESTRING = 3;
   public static final int DISPLAY_TEXT_MAXIMUM_SIZE = 200;
   int contentType;
   DERString contents;

   public DisplayText(int type, String text) {
      if (text.length() > 200) {
         text = text.substring(0, 200);
      }

      this.contentType = type;
      DisplayText var10000;
      DERUTF8String var4;
      switch (type) {
         case 0:
            var10000 = this;
            DERIA5String var6;
            var6 = new DERIA5String.<init>(text);
            var10000.contents = var6;
            break;
         case 1:
            var10000 = this;
            DERBMPString var5;
            var5 = new DERBMPString.<init>(text);
            var10000.contents = var5;
            break;
         case 2:
            var10000 = this;
            var4 = new DERUTF8String.<init>(text);
            var10000.contents = var4;
            break;
         case 3:
            var10000 = this;
            DERVisibleString var3;
            var3 = new DERVisibleString.<init>(text);
            var10000.contents = var3;
            break;
         default:
            var10000 = this;
            var4 = new DERUTF8String.<init>(text);
            var10000.contents = var4;
      }

   }

   public DisplayText(String text) {
      if (text.length() > 200) {
         text = text.substring(0, 200);
      }

      DisplayText var10000 = this;
      this.contentType = 2;
      DERUTF8String var2;
      var2 = new DERUTF8String.<init>(text);
      var10000.contents = var2;
   }

   public DisplayText(DERString de) {
      this.contents = de;
   }

   public static DisplayText getInstance(Object obj) {
      if (obj instanceof DERString) {
         return new DisplayText((DERString)obj);
      } else if (obj instanceof DisplayText) {
         return (DisplayText)obj;
      } else {
         throw new IllegalArgumentException("illegal object in getInstance: " + obj.getClass().getName());
      }
   }

   public static DisplayText getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(obj.getObject());
   }

   public DERObject toASN1Object() {
      return (DERObject)this.contents;
   }

   public String getString() {
      return this.contents.getString();
   }
}
